#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <algorithm>
#include <math.h>

#include "node.h"
#include "nodelist.h"


string file2string( char* filename ){

    char c;
    ifstream fin;
    string str;

    /* read from file */
    fin.open(filename);
    if( fin.fail() ){
	cout << "Error: cannot open file: " << filename << endl;
	exit(1);
    }

    /* join all string */
    while( fin.get(c) ){ str = str + c; }

    return str;

}




int main(int argc, char* argv[]){

    if( argc != 2 ){
	cout << "Usage: htmlparser [filename]" << endl;
	exit(1);
    }
    char* filename = argv[1];

    string filestr = file2string( filename );
    nodelist doc( filestr );

    for(int i=0; i<doc.getSize(); i++){
	printf("%3d ", doc.getID(i) );
	for(int j=0; j<(int)doc.getLevel(i); j++){
	    cout << " |";
	}
	cout << doc.getHtmlNode(i) << " ";
	cout << doc.getParent(i)->getID() << endl;
    }

    /* chidlren check */
    /*
    for(int i=0; i<doc.getSize(); i++){
	vector<node*> children = doc.getChildren(i);
	cout << i << ":";
	for(int j=0; j<(int)children.size(); j++){
	    cout << children[j]->getHtmlNode() << "/";
	} 
	cout << endl;	
    }
    */

    /* path check */
    /*
    for(int i=0; i<doc.getSize(); i++){
	vector<node*> path = doc.getPath(i);
	cout << i << ":";
	for(int j=0; j<(int)path.size(); j++){
	    cout << path[j]->getHtmlNode() << "/";
	} 
	cout << endl;
    }
    */

    /* DFS */
    /* doc.DFS( 5 ); */
    /* vector<node*> dfs; 
    doc.DFS( 5, dfs ); 
    */

    /* BFS */
    /* doc.BFS(0); */
    /*
    vector<node*> bfs; 
    doc.BFS( 5, bfs ); 
    */
    /*
    vector<node*> t = doc.getLevelNodes(0,7);
    for(int i=0; i<(int)t.size(); i++){
	cout << t[i]->getHtmlNode() << endl;
    }
    */

    /* write down to file */
    /* 
    ofstream fout;
    fout.open("output.html");
    if(!fout.is_open()) exit(1);
    doc.writeHtml( 0, fout );
    fout.close();
    */




    return 0;
}

