#ifndef _INC_TREE
#define _TREE

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>
#include <sstream>
#include <iterator>
#include <algorithm>

#include <assert.h>

#define ASSERT(c) assert(c)

using namespace std;


class nodelist {
protected:
    int nodesize;
    node* nodes; /* node list */
private:

    void setNodelist( string, vector<string>& ); 
    void setNodelevel( vector<string>&, vector<int>& );
    int isIgnoreTag( string& );
    int checkRule( string&, string& );
    int removeCloseTag( vector<int>&, vector<string>&, 
			 vector<int>&, vector<string>& );

    node* searchParent(int, vector<int>&, node* );
    void searchChildren(int, vector<int>&, node* );

    vector<int> levelStack;
    vector<string> closeTags;
public:

    /* set */
    nodelist( string );
    ~nodelist();

    /* get */
    node* getNode( int );    /* address */

    int getID( int );
    int getLevel( int );
    string getHtmlNode( int );
    vector<node*> getChildren( int );
    node* getParent( int );
    vector<node*> getPath( int );

    void DFS(int);
    void DFS(int, vector<node*>& );
    void BFS(int);
    void BFS(int, vector<node*>& );
    vector<node*> getLevelNodes(int, int);


    string getLowerString( string );
    string getTagname( string& );
    int getSize();
    void writeHtml(int, ofstream& );
    bool existCloseTag( string );



};

#endif
